--- //depot/projects/trustedbsd/mac/sys/kern/sysv_shm.c	2003/05/05 17:13:02
+++ //depot/user/hdandeka/rishi_SystemVIPC/sys/kern/sysv_shm.c	2003/06/20 08:44:14
@@ -33,6 +33,7 @@
 
 #include "opt_compat.h"
 #include "opt_sysvipc.h"
+#include "opt_mac.h"
 
 #include <sys/param.h>
 #include <sys/systm.h>
@@ -50,6 +51,10 @@
 #include <sys/sysent.h>
 #include <sys/sysproto.h>
 #include <sys/jail.h>
+#ifdef MAC
+#include <sys/_label.h>
+#include <sys/mac.h>
+#endif
 
 #include <vm/vm.h>
 #include <vm/vm_param.h>
@@ -82,7 +87,9 @@
 #define	SHMSEG_WANTED		0x1000
 
 static int shm_last_free, shm_nused, shm_committed, shmalloced;
-static struct shmid_ds	*shmsegs;
+static struct shmid_kernel	*shmsegs;
+static int refcount; /* to ensure consistency during and after shmunload */
+static struct mtx refcnt_mtx;	/* global mutex for refcount. */
 
 struct shm_handle {
 	/* vm_offset_t kva; */
@@ -94,15 +101,16 @@
 	int shmid;
 };
 
-static void shm_deallocate_segment(struct shmid_ds *);
+static void shm_deallocate_segment(struct shmid_kernel *);
 static int shm_find_segment_by_key(key_t);
-static struct shmid_ds *shm_find_segment_by_shmid(int, int);
-static struct shmid_ds *shm_find_segment_by_shmidx(int, int);
+static struct shmid_kernel *shm_find_segment_by_shmid(int, int);
+static struct shmid_kernel *shm_find_segment_by_shmidx(int, int);
 static int shm_delete_mapping(struct vmspace *vm, struct shmmap_state *);
 static void shmrealloc(void);
 static void shminit(void);
 static int sysvshm_modload(struct module *, int, void *);
 static int shmunload(void);
+/* TODO: Look at the following functions w.r.t. the MAC framework */
 static void shmexit_myhook(struct vmspace *vm);
 static void shmfork_myhook(struct proc *p1, struct proc *p2);
 static int sysctl_shmsegs(SYSCTL_HANDLER_ARGS);
@@ -157,66 +165,70 @@
 	int i;
 
 	for (i = 0; i < shmalloced; i++)
-		if ((shmsegs[i].shm_perm.mode & SHMSEG_ALLOCATED) &&
-		    shmsegs[i].shm_perm.key == key)
+		if ((shmsegs[i].u.shm_perm.mode & SHMSEG_ALLOCATED) &&
+		    shmsegs[i].u.shm_perm.key == key)
 			return (i);
 	return (-1);
 }
 
-static struct shmid_ds *
+static struct shmid_kernel *
 shm_find_segment_by_shmid(int shmid, int wantrem)
 {
 	int segnum;
-	struct shmid_ds *shmseg;
+	struct shmid_kernel *shmseg;
 
 	segnum = IPCID_TO_IX(shmid);
 	if (segnum < 0 || segnum >= shmalloced)
 		return (NULL);
 	shmseg = &shmsegs[segnum];
-	if (!((shmseg->shm_perm.mode & SHMSEG_ALLOCATED) ||
-  	    (wantrem && !(shmseg->shm_perm.mode & SHMSEG_REMOVED))) ||
-	    shmseg->shm_perm.seq != IPCID_TO_SEQ(shmid))
+	if (!((shmseg->u.shm_perm.mode & SHMSEG_ALLOCATED) ||
+  	    (wantrem && !(shmseg->u.shm_perm.mode & SHMSEG_REMOVED))) ||
+	    shmseg->u.shm_perm.seq != IPCID_TO_SEQ(shmid))
 		return (NULL);
 	return (shmseg);
 }
 
-static struct shmid_ds *
+static struct shmid_kernel *
 shm_find_segment_by_shmidx(int segnum, int wantrem)
 {
-	struct shmid_ds *shmseg;
+	struct shmid_kernel *shmseg;
 
 	if (segnum < 0 || segnum >= shmalloced)
 		return (NULL);
 	shmseg = &shmsegs[segnum];
-	if (!((shmseg->shm_perm.mode & SHMSEG_ALLOCATED) ||
-  	    (wantrem && !(shmseg->shm_perm.mode & SHMSEG_REMOVED))))
+	if (!((shmseg->u.shm_perm.mode & SHMSEG_ALLOCATED) ||
+  	    (wantrem && !(shmseg->u.shm_perm.mode & SHMSEG_REMOVED))))
 		return (NULL);
 	return (shmseg);
 }
 
 static void
 shm_deallocate_segment(shmseg)
-	struct shmid_ds *shmseg;
+	struct shmid_kernel *shmseg;
 {
 	struct shm_handle *shm_handle;
 	size_t size;
 
 	GIANT_REQUIRED;
 
-	shm_handle = shmseg->shm_internal;
+	shm_handle = shmseg->u.shm_internal;
 	vm_object_deallocate(shm_handle->shm_object);
 	free(shm_handle, M_SHM);
-	shmseg->shm_internal = NULL;
-	size = round_page(shmseg->shm_segsz);
+	shmseg->u.shm_internal = NULL;
+	size = round_page(shmseg->u.shm_segsz);
 	shm_committed -= btoc(size);
 	shm_nused--;
-	shmseg->shm_perm.mode = SHMSEG_FREE;
+	shmseg->u.shm_perm.mode = SHMSEG_FREE;
+#ifdef MAC
+	/* XXX: Reset the MAC label */
+	mac_cleanup_ipc_shm(shmseg);
+#endif
 }
 
 static int
 shm_delete_mapping(struct vmspace *vm, struct shmmap_state *shmmap_s)
 {
-	struct shmid_ds *shmseg;
+	struct shmid_kernel *shmseg;
 	int segnum, result;
 	size_t size;
 
@@ -224,14 +236,14 @@
 
 	segnum = IPCID_TO_IX(shmmap_s->shmid);
 	shmseg = &shmsegs[segnum];
-	size = round_page(shmseg->shm_segsz);
+	size = round_page(shmseg->u.shm_segsz);
 	result = vm_map_remove(&vm->vm_map, shmmap_s->va, shmmap_s->va + size);
 	if (result != KERN_SUCCESS)
 		return (EINVAL);
 	shmmap_s->shmid = -1;
-	shmseg->shm_dtime = time_second;
-	if ((--shmseg->shm_nattch <= 0) &&
-	    (shmseg->shm_perm.mode & SHMSEG_REMOVED)) {
+	shmseg->u.shm_dtime = time_second;
+	if ((--shmseg->u.shm_nattch <= 0) &&
+	    (shmseg->u.shm_perm.mode & SHMSEG_REMOVED)) {
 		shm_deallocate_segment(shmseg);
 		shm_last_free = segnum;
 	}
@@ -259,6 +271,16 @@
 
 	if (!jail_sysvipc_allowed && jailed(td->td_ucred))
 		return (ENOSYS);
+
+	/* Prevent thread from going any further if module is (being) unloaded */
+	mtx_lock(&refcnt_mtx);
+	if (refcount < 0 ) {
+		mtx_unlock(&refcnt_mtx);
+		return (ENOSYS);
+	}
+	refcount++; /* Indicate that thread is active in the code-path */
+	mtx_unlock(&refcnt_mtx);
+
 	mtx_lock(&Giant);
 	shmmap_s = p->p_vmspace->vm_shm;
  	if (shmmap_s == NULL) {
@@ -275,9 +297,21 @@
 		error = EINVAL;
 		goto done2;
 	}
+#ifdef MAC
+	/* XXX It might be useful to move this into the shm_delete_mapping function */
+	struct shmid_kernel *shmsegptr;
+	shmsegptr = &shmsegs[IPCID_TO_IX(shmmap_s->shmid)];
+  if(( error = mac_check_ipc_shmdt(td->td_ucred, shmsegptr) )) { 
+    printf(("MAC Framework:  mac_check_ipc_shmdt access denied\n"));
+    goto done2;
+  }
+#endif
 	error = shm_delete_mapping(p->p_vmspace, shmmap_s);
 done2:
 	mtx_unlock(&Giant);
+	mtx_lock(&refcnt_mtx);
+	refcount--; /* Indicate that thread no longer active in the code-path */
+	mtx_unlock(&refcnt_mtx);
 	return (error);
 }
 
@@ -302,7 +336,7 @@
 {
 	struct proc *p = td->td_proc;
 	int i, flags;
-	struct shmid_ds *shmseg;
+	struct shmid_kernel *shmseg;
 	struct shmmap_state *shmmap_s = NULL;
 	struct shm_handle *shm_handle;
 	vm_offset_t attach_va;
@@ -313,6 +347,16 @@
 
 	if (!jail_sysvipc_allowed && jailed(td->td_ucred))
 		return (ENOSYS);
+
+	/* Prevent thread from going any further if module is (being) unloaded */
+	mtx_lock(&refcnt_mtx);
+	if (refcount < 0 ) {
+		mtx_unlock(&refcnt_mtx);
+		return (ENOSYS);
+	}
+	refcount++; /* Indicate that thread is active in the code-path */
+	mtx_unlock(&refcnt_mtx);
+
 	mtx_lock(&Giant);
 	shmmap_s = p->p_vmspace->vm_shm;
 	if (shmmap_s == NULL) {
@@ -327,10 +371,16 @@
 		error = EINVAL;
 		goto done2;
 	}
-	error = ipcperm(td, &shmseg->shm_perm,
+	error = ipcperm(td, &shmseg->u.shm_perm,
 	    (shmflg & SHM_RDONLY) ? IPC_R : IPC_R|IPC_W);
 	if (error)
 		goto done2;
+#ifdef MAC
+  if(( error = mac_check_ipc_shmat(td->td_ucred, shmseg, shmflg) )) { 
+    printf(("MAC Framework:  mac_check_ipc_shmat access denied\n"));
+    goto done2;
+  }
+#endif
 	for (i = 0; i < shminfo.shmseg; i++) {
 		if (shmmap_s->shmid == -1)
 			break;
@@ -340,7 +390,7 @@
 		error = EMFILE;
 		goto done2;
 	}
-	size = round_page(shmseg->shm_segsz);
+	size = round_page(shmseg->u.shm_segsz);
 #ifdef VM_PROT_READ_IS_EXEC
 	prot = VM_PROT_READ | VM_PROT_EXECUTE;
 #else
@@ -368,7 +418,7 @@
 		    + maxtsiz + maxdsiz);
 	}
 
-	shm_handle = shmseg->shm_internal;
+	shm_handle = shmseg->u.shm_internal;
 	vm_object_reference(shm_handle->shm_object);
 	rv = vm_map_find(&p->p_vmspace->vm_map, shm_handle->shm_object,
 		0, &attach_va, size, (flags & MAP_FIXED)?0:1, prot, prot, 0);
@@ -381,12 +431,15 @@
 
 	shmmap_s->va = attach_va;
 	shmmap_s->shmid = shmid;
-	shmseg->shm_lpid = p->p_pid;
-	shmseg->shm_atime = time_second;
-	shmseg->shm_nattch++;
+	shmseg->u.shm_lpid = p->p_pid;
+	shmseg->u.shm_atime = time_second;
+	shmseg->u.shm_nattch++;
 	td->td_retval[0] = attach_va;
 done2:
 	mtx_unlock(&Giant);
+	mtx_lock(&refcnt_mtx);
+	refcount--; /* Indicate that thread no longer active in the code-path */
+	mtx_unlock(&refcnt_mtx);
 	return (error);
 }
 
@@ -426,11 +479,21 @@
 {
 #ifdef COMPAT_43
 	int error = 0;
-	struct shmid_ds *shmseg;
+	struct shmid_kernel *shmseg;
 	struct oshmid_ds outbuf;
 
 	if (!jail_sysvipc_allowed && jailed(td->td_ucred))
 		return (ENOSYS);
+
+	/* Prevent thread from going any further if module is (being) unloaded */
+	mtx_lock(&refcnt_mtx);
+	if (refcount < 0 ) {
+		mtx_unlock(&refcnt_mtx);
+		return (ENOSYS);
+	}
+	refcount++; /* Indicate that thread is active in the code-path */
+	mtx_unlock(&refcnt_mtx);
+
 	mtx_lock(&Giant);
 	shmseg = shm_find_segment_by_shmid(uap->shmid, 0);
 	if (shmseg == NULL) {
@@ -439,18 +502,24 @@
 	}
 	switch (uap->cmd) {
 	case IPC_STAT:
-		error = ipcperm(td, &shmseg->shm_perm, IPC_R);
+		error = ipcperm(td, &shmseg->u.shm_perm, IPC_R);
 		if (error)
 			goto done2;
-		outbuf.shm_perm = shmseg->shm_perm;
-		outbuf.shm_segsz = shmseg->shm_segsz;
-		outbuf.shm_cpid = shmseg->shm_cpid;
-		outbuf.shm_lpid = shmseg->shm_lpid;
-		outbuf.shm_nattch = shmseg->shm_nattch;
-		outbuf.shm_atime = shmseg->shm_atime;
-		outbuf.shm_dtime = shmseg->shm_dtime;
-		outbuf.shm_ctime = shmseg->shm_ctime;
-		outbuf.shm_handle = shmseg->shm_internal;
+#ifdef MAC
+  	if(( error = mac_check_ipc_shmctl(td->td_ucred, shmseg, uap->cmd) )) {
+    	printf(("MAC Framework:  mac_check_ipc_shmctl access denied\n"));
+    	goto done2;
+  	}
+#endif
+		outbuf.shm_perm = shmseg->u.shm_perm;
+		outbuf.shm_segsz = shmseg->u.shm_segsz;
+		outbuf.shm_cpid = shmseg->u.shm_cpid;
+		outbuf.shm_lpid = shmseg->u.shm_lpid;
+		outbuf.shm_nattch = shmseg->u.shm_nattch;
+		outbuf.shm_atime = shmseg->u.shm_atime;
+		outbuf.shm_dtime = shmseg->u.shm_dtime;
+		outbuf.shm_ctime = shmseg->u.shm_ctime;
+		outbuf.shm_handle = shmseg->u.shm_internal;
 		error = copyout(&outbuf, uap->ubuf, sizeof(outbuf));
 		if (error)
 			goto done2;
@@ -462,6 +531,9 @@
 	}
 done2:
 	mtx_unlock(&Giant);
+	mtx_lock(&refcnt_mtx);
+	refcount--; /* Indicate that thread no longer active in the code-path */
+	mtx_unlock(&refcnt_mtx);
 	return (error);
 #else
 	return (EINVAL);
@@ -489,11 +561,20 @@
 	int wantrem;
 {
 	int error = 0;
-	struct shmid_ds *shmseg;
+	struct shmid_kernel *shmseg;
 
 	if (!jail_sysvipc_allowed && jailed(td->td_ucred))
 		return (ENOSYS);
 
+	/* Prevent thread from going any further if module is (being) unloaded */
+	mtx_lock(&refcnt_mtx);
+	if (refcount < 0 ) {
+		mtx_unlock(&refcnt_mtx);
+		return (ENOSYS);
+	}
+	refcount++; /* Indicate that thread is active in the code-path */
+	mtx_unlock(&refcnt_mtx);
+
 	mtx_lock(&Giant);
 	switch (cmd) {
 	case IPC_INFO:
@@ -525,40 +606,46 @@
 		error = EINVAL;
 		goto done2;
 	}
+#ifdef MAC
+  if(( error = mac_check_ipc_shmctl(td->td_ucred, shmseg, cmd) )) {
+  	printf(("MAC Framework:  mac_check_ipc_shmctl access denied\n"));
+  	goto done2;
+  }
+#endif
 	switch (cmd) {
 	case SHM_STAT:
 	case IPC_STAT:
-		error = ipcperm(td, &shmseg->shm_perm, IPC_R);
+		error = ipcperm(td, &shmseg->u.shm_perm, IPC_R);
 		if (error)
 			goto done2;
-		memcpy(buf, shmseg, sizeof(struct shmid_ds));
+		memcpy(buf, &shmseg->u, sizeof(struct shmid_ds));
 		if (bufsz)
 			*bufsz = sizeof(struct shmid_ds);
 		if (cmd == SHM_STAT)
-			td->td_retval[0] = IXSEQ_TO_IPCID(shmid, shmseg->shm_perm);
+			td->td_retval[0] = IXSEQ_TO_IPCID(shmid, shmseg->u.shm_perm);
 		break;
 	case IPC_SET: {
 		struct shmid_ds *shmid;
 
 		shmid = (struct shmid_ds *)buf;
-		error = ipcperm(td, &shmseg->shm_perm, IPC_M);
+		error = ipcperm(td, &shmseg->u.shm_perm, IPC_M);
 		if (error)
 			goto done2;
-		shmseg->shm_perm.uid = shmid->shm_perm.uid;
-		shmseg->shm_perm.gid = shmid->shm_perm.gid;
-		shmseg->shm_perm.mode =
-		    (shmseg->shm_perm.mode & ~ACCESSPERMS) |
+		shmseg->u.shm_perm.uid = shmid->shm_perm.uid;
+		shmseg->u.shm_perm.gid = shmid->shm_perm.gid;
+		shmseg->u.shm_perm.mode =
+		    (shmseg->u.shm_perm.mode & ~ACCESSPERMS) |
 		    (shmid->shm_perm.mode & ACCESSPERMS);
-		shmseg->shm_ctime = time_second;
+		shmseg->u.shm_ctime = time_second;
 		break;
 	}
 	case IPC_RMID:
-		error = ipcperm(td, &shmseg->shm_perm, IPC_M);
+		error = ipcperm(td, &shmseg->u.shm_perm, IPC_M);
 		if (error)
 			goto done2;
-		shmseg->shm_perm.key = IPC_PRIVATE;
-		shmseg->shm_perm.mode |= SHMSEG_REMOVED;
-		if (shmseg->shm_nattch <= 0) {
+		shmseg->u.shm_perm.key = IPC_PRIVATE;
+		shmseg->u.shm_perm.mode |= SHMSEG_REMOVED;
+		if (shmseg->u.shm_nattch <= 0) {
 			shm_deallocate_segment(shmseg);
 			shm_last_free = IPCID_TO_IX(shmid);
 		}
@@ -573,6 +660,9 @@
 	}
 done2:
 	mtx_unlock(&Giant);
+	mtx_lock(&refcnt_mtx);
+	refcount--; /* Indicate that thread no longer active in the code-path */
+	mtx_unlock(&refcnt_mtx);
 	return (error);
 }
 
@@ -629,17 +719,17 @@
 	int mode;
 	int segnum;
 {
-	struct shmid_ds *shmseg;
+	struct shmid_kernel *shmseg;
 	int error;
 
 	shmseg = &shmsegs[segnum];
-	if (shmseg->shm_perm.mode & SHMSEG_REMOVED) {
+	if (shmseg->u.shm_perm.mode & SHMSEG_REMOVED) {
 		/*
 		 * This segment is in the process of being allocated.  Wait
 		 * until it's done, and look the key up again (in case the
 		 * allocation failed or it was freed).
 		 */
-		shmseg->shm_perm.mode |= SHMSEG_WANTED;
+		shmseg->u.shm_perm.mode |= SHMSEG_WANTED;
 		error = tsleep(shmseg, PLOCK | PCATCH, "shmget", 0);
 		if (error)
 			return (error);
@@ -647,12 +737,17 @@
 	}
 	if ((uap->shmflg & (IPC_CREAT | IPC_EXCL)) == (IPC_CREAT | IPC_EXCL))
 		return (EEXIST);
-	error = ipcperm(td, &shmseg->shm_perm, mode);
+	error = ipcperm(td, &shmseg->u.shm_perm, mode);
+#ifdef MAC
+	if(( error = mac_check_ipc_shmget(td->td_ucred,shmseg,uap->shmflg) )) {
+		printf(("MAC Framework:  mac_check_ipc_shmget access denied\n"));
+	}
+#endif
 	if (error)
 		return (error);
-	if (uap->size && uap->size > shmseg->shm_segsz)
+	if (uap->size && uap->size > shmseg->u.shm_segsz)
 		return (EINVAL);
-	td->td_retval[0] = IXSEQ_TO_IPCID(segnum, shmseg->shm_perm);
+	td->td_retval[0] = IXSEQ_TO_IPCID(segnum, shmseg->u.shm_perm);
 	return (0);
 }
 
@@ -664,7 +759,7 @@
 {
 	int i, segnum, shmid, size;
 	struct ucred *cred = td->td_ucred;
-	struct shmid_ds *shmseg;
+	struct shmid_kernel *shmseg;
 	struct shm_handle *shm_handle;
 
 	GIANT_REQUIRED;
@@ -679,7 +774,7 @@
 	if (shm_last_free < 0) {
 		shmrealloc();	/* Maybe expand the shmsegs[] array. */
 		for (i = 0; i < shmalloced; i++)
-			if (shmsegs[i].shm_perm.mode & SHMSEG_FREE)
+			if (shmsegs[i].u.shm_perm.mode & SHMSEG_FREE)
 				break;
 		if (i == shmalloced)
 			return (ENOSPC);
@@ -693,12 +788,12 @@
 	 * In case we sleep in malloc(), mark the segment present but deleted
 	 * so that noone else tries to create the same key.
 	 */
-	shmseg->shm_perm.mode = SHMSEG_ALLOCATED | SHMSEG_REMOVED;
-	shmseg->shm_perm.key = uap->key;
-	shmseg->shm_perm.seq = (shmseg->shm_perm.seq + 1) & 0x7fff;
+	shmseg->u.shm_perm.mode = SHMSEG_ALLOCATED | SHMSEG_REMOVED;
+	shmseg->u.shm_perm.key = uap->key;
+	shmseg->u.shm_perm.seq = (shmseg->u.shm_perm.seq + 1) & 0x7fff;
 	shm_handle = (struct shm_handle *)
 	    malloc(sizeof(struct shm_handle), M_SHM, M_WAITOK);
-	shmid = IXSEQ_TO_IPCID(segnum, shmseg->shm_perm);
+	shmid = IXSEQ_TO_IPCID(segnum, shmseg->u.shm_perm);
 	
 	/*
 	 * We make sure that we have allocated a pager before we need
@@ -716,24 +811,27 @@
 	vm_object_set_flag(shm_handle->shm_object, OBJ_NOSPLIT);
 	VM_OBJECT_UNLOCK(shm_handle->shm_object);
 
-	shmseg->shm_internal = shm_handle;
-	shmseg->shm_perm.cuid = shmseg->shm_perm.uid = cred->cr_uid;
-	shmseg->shm_perm.cgid = shmseg->shm_perm.gid = cred->cr_gid;
-	shmseg->shm_perm.mode = (shmseg->shm_perm.mode & SHMSEG_WANTED) |
+	shmseg->u.shm_internal = shm_handle;
+	shmseg->u.shm_perm.cuid = shmseg->u.shm_perm.uid = cred->cr_uid;
+	shmseg->u.shm_perm.cgid = shmseg->u.shm_perm.gid = cred->cr_gid;
+	shmseg->u.shm_perm.mode = (shmseg->u.shm_perm.mode & SHMSEG_WANTED) |
 	    (mode & ACCESSPERMS) | SHMSEG_ALLOCATED;
-	shmseg->shm_segsz = uap->size;
-	shmseg->shm_cpid = td->td_proc->p_pid;
-	shmseg->shm_lpid = shmseg->shm_nattch = 0;
-	shmseg->shm_atime = shmseg->shm_dtime = 0;
-	shmseg->shm_ctime = time_second;
+	shmseg->u.shm_segsz = uap->size;
+	shmseg->u.shm_cpid = td->td_proc->p_pid;
+	shmseg->u.shm_lpid = shmseg->u.shm_nattch = 0;
+	shmseg->u.shm_atime = shmseg->u.shm_dtime = 0;
+#ifdef MAC
+  mac_create_ipc_shm(cred, shmseg);
+#endif
+	shmseg->u.shm_ctime = time_second;
 	shm_committed += btoc(size);
 	shm_nused++;
-	if (shmseg->shm_perm.mode & SHMSEG_WANTED) {
+	if (shmseg->u.shm_perm.mode & SHMSEG_WANTED) {
 		/*
 		 * Somebody else wanted this key while we were asleep.  Wake
 		 * them up now.
 		 */
-		shmseg->shm_perm.mode &= ~SHMSEG_WANTED;
+		shmseg->u.shm_perm.mode &= ~SHMSEG_WANTED;
 		wakeup(shmseg);
 	}
 	td->td_retval[0] = shmid;
@@ -753,6 +851,16 @@
 
 	if (!jail_sysvipc_allowed && jailed(td->td_ucred))
 		return (ENOSYS);
+
+	/* Prevent thread from going any further if module is (being) unloaded */
+	mtx_lock(&refcnt_mtx);
+	if (refcount < 0 ) {
+		mtx_unlock(&refcnt_mtx);
+		return (ENOSYS);
+	}
+	refcount++; /* Indicate that thread is active in the code-path */
+	mtx_unlock(&refcnt_mtx);
+
 	mtx_lock(&Giant);
 	mode = uap->shmflg & ACCESSPERMS;
 	if (uap->key != IPC_PRIVATE) {
@@ -772,6 +880,9 @@
 	error = shmget_allocate_segment(td, uap, mode);
 done2:
 	mtx_unlock(&Giant);
+	mtx_lock(&refcnt_mtx);
+	refcount--; /* Indicate that thread no longer active in the code-path */
+	mtx_unlock(&refcnt_mtx);
 	return (error);
 }
 
@@ -815,7 +926,7 @@
 	p2->p_vmspace->vm_shm = shmmap_s;
 	for (i = 0; i < shminfo.shmseg; i++, shmmap_s++)
 		if (shmmap_s->shmid != -1)
-			shmsegs[IPCID_TO_IX(shmmap_s->shmid)].shm_nattch++;
+			shmsegs[IPCID_TO_IX(shmmap_s->shmid)].u.shm_nattch++;
 }
 
 static void
@@ -830,6 +941,7 @@
 		vm->vm_shm = NULL;
 		for (i = 0, shm = base; i < shminfo.shmseg; i++, shm++) {
 			if (shm->shmid != -1)
+				/* XXX: Should the MAC framework enforce check here as well */
 				shm_delete_mapping(vm, shm);
 		}
 		free(base, M_SHM);
@@ -840,7 +952,7 @@
 shmrealloc(void)
 {
 	int i;
-	struct shmid_ds *newsegs;
+	struct shmid_kernel *newsegs;
 
 	if (shmalloced >= shminfo.shmmni)
 		return;
@@ -851,8 +963,11 @@
 	for (i = 0; i < shmalloced; i++)
 		bcopy(&shmsegs[i], &newsegs[i], sizeof(newsegs[0]));
 	for (; i < shminfo.shmmni; i++) {
-		shmsegs[i].shm_perm.mode = SHMSEG_FREE;
-		shmsegs[i].shm_perm.seq = 0;
+		shmsegs[i].u.shm_perm.mode = SHMSEG_FREE;
+		shmsegs[i].u.shm_perm.seq = 0;
+#ifdef MAC
+		mac_init_ipc_shm(&shmsegs[i]);
+#endif
 	}
 	free(shmsegs, M_SHM);
 	shmsegs = newsegs;
@@ -880,23 +995,53 @@
 	if (shmsegs == NULL)
 		panic("cannot allocate initial memory for sysvshm");
 	for (i = 0; i < shmalloced; i++) {
-		shmsegs[i].shm_perm.mode = SHMSEG_FREE;
-		shmsegs[i].shm_perm.seq = 0;
+		shmsegs[i].u.shm_perm.mode = SHMSEG_FREE;
+		shmsegs[i].u.shm_perm.seq = 0;
+#ifdef MAC
+		mac_init_ipc_shm(&shmsegs[i]);
+#endif
 	}
 	shm_last_free = 0;
 	shm_nused = 0;
 	shm_committed = 0;
 	shmexit_hook = &shmexit_myhook;
 	shmfork_hook = &shmfork_myhook;
+	refcount = 0;
+	/* 
+	 * It is not permissible to pass the same mutex to mtx_init() multiple 
+	 * times without intervening calls to mtx_destroy().
+	 * Since we cannot destroy the refcnt_mtx during shmunload, we check if the 
+	 * mtx_init has ever been called. If so, we dont need to do mtx_init as the 
+	 * mutex is already initialized.
+	 */
+	if ( mtx_initialized(&refcnt_mtx) == 0 )
+		mtx_init(&refcnt_mtx, "shmrefcnt", NULL, MTX_DEF);
 }
 
 static int
 shmunload()
 {
 
-	if (shm_nused > 0)
+	/* 
+	 * Make sure that the shmunload maintains the consistency of the shmsegs
+	 * data structure. This assures that the unload doesn't take place if any 
+	 * thread is in any of the code-paths (tinkering with the data structures), 
+	 * and also that no thread can enter the code-paths once the module is 
+	 * unloaded. 
+	 */
+	mtx_lock(&refcnt_mtx);
+	if ((refcount > 0) || (shm_nused > 0)) {
+		mtx_unlock(&refcnt_mtx);
 		return (EBUSY);
+	}
+	refcount= -1; /* Mark the module as being unloaded */
+	mtx_unlock(&refcnt_mtx);
 
+#ifdef MAC
+	int i;	
+	for (i = 0; i < shmalloced; i++) 
+  	mac_destroy_ipc_shm(&shmsegs[i]);
+#endif
 	free(shmsegs, M_SHM);
 	shmexit_hook = NULL;
 	shmfork_hook = NULL;
@@ -907,6 +1052,7 @@
 sysctl_shmsegs(SYSCTL_HANDLER_ARGS)
 {
 
+	/* TODO: Change from shmid_ds to shmid_kernel needs to be incorporated */
 	return (SYSCTL_OUT(req, shmsegs, shmalloced * sizeof(shmsegs[0])));
 }
 
--- //depot/projects/trustedbsd/mac/sys/modules/sysvipc/sysvmsg/Makefile	2001/11/17 06:10:00
+++ //depot/user/hdandeka/rishi_SystemVIPC/sys/modules/sysvipc/sysvmsg/Makefile	2003/05/23 16:38:07
@@ -3,6 +3,6 @@
 .PATH: ${.CURDIR}/../../../kern
 
 KMOD=	sysvmsg
-SRCS=	sysv_msg.c opt_sysvipc.h
+SRCS=	sysv_msg.c opt_sysvipc.h opt_mac.h
 
 .include <bsd.kmod.mk>
--- //depot/projects/trustedbsd/mac/sys/modules/sysvipc/sysvsem/Makefile	2001/11/17 06:10:00
+++ //depot/user/hdandeka/rishi_SystemVIPC/sys/modules/sysvipc/sysvsem/Makefile	2003/05/30 18:42:59
@@ -3,6 +3,6 @@
 .PATH: ${.CURDIR}/../../../kern
 
 KMOD=	sysvsem
-SRCS=	sysv_sem.c opt_sysvipc.h
+SRCS=	sysv_sem.c opt_sysvipc.h opt_mac.h
 
 .include <bsd.kmod.mk>
--- //depot/projects/trustedbsd/mac/sys/modules/sysvipc/sysvshm/Makefile	2001/11/17 06:10:00
+++ //depot/user/hdandeka/rishi_SystemVIPC/sys/modules/sysvipc/sysvshm/Makefile	2003/06/03 19:22:59
@@ -3,7 +3,7 @@
 .PATH: ${.CURDIR}/../../../kern
 
 KMOD=	sysvshm
-OPTS=	opt_sysvipc.h opt_compat.h
+OPTS=	opt_sysvipc.h opt_compat.h opt_mac.h
 SRCS=	sysv_shm.c $(OPTS)
 
 .include <bsd.kmod.mk>
